#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

//STRC.smart_time_divide=true;

cam.fname="scenes/spiral";
cam.width=200; cam.height=200;
cam.CT=new TTransformation(0,TIME);
cam.CT->translate(
  Create_TVector(0,0,20, 0,TIME));
cam.CT->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
cam.CT->translate(
  Create_TVector(50,0,0, 0,TIME)
  //Create_TVector_linear_through(Vector(40,0,-50),Vector(40,0,50),0,TIME)
);
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.07,0,TIME);
cam.xs=cam.ys=new FN_constant(0.05, 0,TIME);
cam.end_time=TIME; cam.framesec=8;
cam.backdrop=Colour(0.4,0.4,0.7);
cam.sub=2;
cam.motion_blur=true;
cam.anti_alias=false;
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.7;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=2;
//ki.bv_ify=true;
Surface_Info si;

si.kdr=0.7; si.ksr=0.4; si.n=5;
si.dcolour=Colour(0.4,0.8,0.9);
si.rcolour=Colour(1,1,1);

Object *sphere=Create_Static_Sphere(Vector(0,0,0),1,0,TIME,si);
#define NUM 3
#define SPACING (20.0/NUM)
#define CORNER (-NUM*0.5*SPACING)
for(int X=0;X<NUM;X++)
for(int Y=0;Y<NUM;Y++)
for(int Z=0;Z<NUM;Z++){
	Transformation *T;
	TTransformation *TT;
	if(X&1){
		T=new Transformation;
#define W (SPACING*0.2)
		T->scale(Vector(W,W,W));
		T->translate(
		  Vector(CORNER+X*SPACING,CORNER+Y*SPACING,CORNER+Z*SPACING)
		);
		K_add_object(Transform_Object(sphere,T));
	}
	else{
		TT=new TTransformation(0,TIME);
		TT->scale(Create_TVector(W,W,W, 0,TIME));
		TT->translate(Create_TVector(0,W*2,0 ,0,TIME));
		TT->rotateZ(new FN_constant(K_random()*2*PI, 0,TIME));
		TT->rotateZ(Create_FN_linear_through(0,2*PI,0,TIME));
		TT->rotateX(new FN_constant(K_random()*2*PI, 0,TIME));
		TT->translate(
		  Create_TVector(CORNER+X*SPACING,CORNER+Y*SPACING,CORNER+Z*SPACING, 0,TIME)
		);
		K_add_object(Transform_Object(sphere,TT));
	}
}

si.kdr=0.4; si.ksr=0.9; si.n=2;
si.dcolour=Colour(0.2,0.8,0.7);
si.rcolour=Colour(1,1,1);
Vector V[4]={
Vector(1,1,0),Vector(1,-1,0),Vector(-1,-1,0),Vector(-1,1,0)};
Transformation *T=new Transformation;
T->scale(Vector(15,15,15));
T->translate(Vector(0,0,CORNER-2));
T->rotateY(PI/2);
K_add_object(
  Transform_Object(Create_Polygon(4,V,0,TIME,si),T)
);

K_add_light(new Light(
  TVector(
    new FN_constant(30,0,TIME),
    new FN_constant(10,0,TIME),
    new FN_constant(20,0,TIME)
  ),
  Colour(0.8,0.8,0.8) ) );

}


