#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

STRC.smart_time_divide=true;

cam.fname="scenes/spiral";
cam.width=200; cam.height=200;
cam.CT=new TTransformation(0,TIME);
cam.CT->translate(
  Create_TVector(50,0,0, 0,TIME)
  //Create_TVector_linear_through(Vector(50,-15,0),Vector(50,15,0),0,TIME)
);
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.07,0,TIME);
cam.xs=cam.ys=new FN_constant(0.05, 0,TIME);
cam.end_time=TIME; cam.framesec=8;
cam.backdrop=Colour(0.4,0.4,0.7);
cam.sub=2;
cam.motion_blur=true;
cam.anti_alias=false;
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.7;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=2;
//ki.bv_ify=true;
Surface_Info si;

si.kdr=0.7; si.ksr=0.4; si.n=5;
si.dcolour=Colour(0.4,0.8,0.9);
si.rcolour=Colour(1,1,1);

Object *sphere=Create_Static_Sphere(Vector(0,0,0),1,0,TIME,si);
for(int i=0;i<7;i++){
	Transformation *T=new Transformation;
	T->scale(Vector(10,1.8,10));
	//T->rotateX(-PI/4);
	T->translate(Vector(0,i*2-14,0));
	K_add_object(Transform_Object(sphere,T));
}

si.dcolour=Colour(0.8,0.2,0.2);
TTransformation *T=new TTransformation(0,TIME);
T->translate(Create_TVector_linear_through(Vector(14,10,0),Vector(14,-10,0),0,TIME));
K_add_object(Transform_Object(sphere,T,si));

K_add_light(new Light(
  TVector(
    new FN_constant(30,0,TIME),
    new FN_constant(10,0,TIME),
    new FN_constant(20,0,TIME)
  ),
  Colour(0.8,0.8,0.8) ) );

}


