#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{


cam.fname="scenes/spiral";
cam.width=256; cam.height=256;
cam.CT=new TTransformation(0,TIME);
cam.CT->translate(
  Create_TVector(30,0,0, 0,TIME)
  //Create_TVector_linear_through(Vector(30,-20,0),Vector(30,20,0),0,TIME)
);
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.1,0,TIME);
cam.xs=cam.ys=new FN_constant(0.1, 0,TIME);
cam.end_time=TIME; cam.framesec=12;
cam.backdrop=Colour(0.4,0.4,0.7);
cam.sub=1;
cam.motion_blur=true;
cam.anti_alias=true;
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.7;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=2;
//ki.bv_ify=true;

Surface_Info si;

si.kdr=0.7; si.ksr=0.8; si.n=5;
si.dcolour=Colour(0.4,0.8,0.9);
si.rcolour=Colour(1,1,1);
//si.tcolour=Colour(1,1,1); si.ior=1.4; si.kst=1;
Vector V[4]={
Vector(1,1,0),Vector(1,-1,0),Vector(-1,-1,0),Vector(-1,1,0)};
Object *poly=Create_Polygon(4,V,0,TIME,si);

#define WIDTH 2
#define STEP (20.0/WIDTH)
for(int X=0;X<WIDTH;X++)
for(int Y=0;Y<WIDTH;Y++)
for(int Z=0;Z<WIDTH;Z++){
	TTransformation* T=new TTransformation(0,TIME);
	T->scale(Create_TVector(1,1,1, 0,TIME));
	T->translate(Create_TVector(0,STEP*0.25,0, 0,TIME));
	T->rotateZ(new FN_constant(K_random()*2*PI, 0,TIME));
	T->rotateZ(Create_FN_linear_through(0,2*PI,0,TIME));
	T->rotateX(new FN_constant(K_random()*2*PI, 0,TIME));
	T->translate(Create_TVector(-10+STEP*X,-10+STEP*Y,-10+STEP*Z,0,TIME));
	K_add_object(
		Transform_Object(
		  /*Create_Static_Sphere(
		    Vector(0,0,0),STEP*0.15, 0,TIME,si
		  )*/
		  poly
		  ,T
		)
	);
}

K_add_light(new Light(
  TVector(
    new FN_constant(30,0,TIME),
    new FN_constant(10,0,TIME),
    new FN_constant(20,0,TIME)
  ),
  Colour(0.8,0.8,0.8) ) );

}


