#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"

#define TIME 1
Camera cam;
void user_create_scene(Kernel_Info& ki)
{

cam.fname="scenes/test";
cam.width=200; cam.height=200;
cam.C=
  //Create_TVector(20,0,10);
  /**/TVector(
    Create_FN_linear_through(-60,-40,0,TIME),
    new FN_constant(30),
    Create_FN_linear_through(0,-20,0,TIME)
);/**/

cam.look_at=Create_TVector(0,0,0);
cam.up=Create_TVector(0,0,1);
cam.f=new FN_constant(5);
cam.xs=new FN_constant(3); cam.ys=new FN_constant(3);
cam.end_time=TIME; cam.framesec=10;
cam.backdrop=Colour(0.4,0.4,0.7);
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.ambient=Colour(0.0,0.0,0.0);

K_init_camera(&cam);
Surface_Info si;

si.kdr=0.9; si.ksr=0.9; si.n=10;
si.dcolour=Colour(1,0.4,0.5);
si.rcolour=Colour(1,1,1);

Object *sphere=Create_Static_Sphere(Vector(0,0,0),1,si);
TTransformation *T=new TTransformation;
T->scale(Create_TVector_linear_through(
  Vector(2,4,2),Vector(2,1,2),0,TIME
));
T->rotateX(Create_FN_linear_through(0,PI,0,TIME));
T->translate(Create_TVector_linear_through(
  Vector(1,0,0),Vector(-1,1,2),0,TIME
));
K_add_object(
  Transform_Object(sphere,T)
);

si.kdr=0.9; si.ksr=0.0; si.n=2;
si.dcolour=Colour(0.2,0.8,0.7);
si.rcolour=Colour(1,1,1);
Vector V[4]={
Vector(5,5,0),Vector(5,-5,0),Vector(-5,-5,0),Vector(-5,5,0)};
K_add_object(
  Create_Polygon(4,V,si)
);

K_add_light(new Light(
  TVector(
    new FN_constant(10),
    new FN_constant(10),
    new FN_constant(10)
  ),
  Colour(1,1,1) ) );

}


