#ifndef __SOURECEGEN_H
#define __SOURCEGEN_H

#include "config.h"

#include "List.h"

// some useful string functions
char* STR_dup(char*);
char* STR_add(char*,char*);
char* STR_add(int n, char**);

class Object; // forward decls
class TTransformation;
class Transformation;
class Function;
class Camera;
class Light;
struct Kernel_Info;


class Source_Generator{
public:
	Source_Generator(char*Fname);
	void generate_code(Kernel_Info*); // outputs final product to file

	void add_object_code(Object*,char*);
	void add_transform_code(Transformation*,char*);
	void add_ttransform_code(TTransformation*,char*);
	void add_function_code(Function*,char*);
	void add_light_code(Light*,char*);
	void add_camera_code(Camera*,char*);

	// these make C++ identifiers from pointers
	// buf should be this big
#define SG_ID_LEN 32
	static char* name_of(Object*,char* buf);
	static char* name_of(Transformation*,char* buf);
	static char* name_of(TTransformation*,char* buf);
	static char* name_of(Function*,char* buf);
	static char* name_of(Light*,char* buf);
	
private:
	List<Object*> objects;
	List<char*> object_code;
	List<Transformation*> trans;
	List<char*> trans_code;
	List<TTransformation*> ttrans;
	List<char*> ttrans_code;
	List<Function*> functions;
	List<char*> function_code;
	List<Light*> lights;
	List<char*> light_code;
	char* camera_code;
	char* fname;
};


#endif

void Light_generate_code(Light*,Source_Generator*);

