#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 4.0

void add_rectZ(Vector p,Float x,Float y,Surface_Info si)
{
        Vector V[4];
        V[0]=p; V[1]=p+Vector(0,y,0);
        V[2]=p+Vector(x,y,0); V[3]=p+Vector(x,0,0);
        K_add_object(Create_Polygon(4,V,0,TIME,si));
}

void add_atom(Vector p)
{
Surface_Info si;
si.kdr=1; si.ksr=0; si.n=1;
si.dcolour=Colour(0.2,1,0.3);
K_add_object(Create_Static_Sphere(p,1.5,0,TIME,si));
TTransformation *T;

si.dcolour=Colour(0.2,0.2,1);
T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,2.5, 0,TIME));
T->rotateY(new FN_constant(K_random()*2*PI,0,TIME));
T->rotateY(Create_FN_linear_through(0,4*PI,0,TIME));
T->rotateX(new FN_constant(K_random()*2*PI,0,TIME));
T->translate(Create_TVector(p.x,p.y,p.z,0,TIME));
K_add_object(Transform_Object(Create_Static_Sphere(Vector(0,0,0),0.5,0,TIME,si),T));

si.kdr=0.8; si.ksr=0.7; si.kst=1; si.ior=1.05;
si.dcolour=Colour(0.3,0.3,0.3);
si.rcolour=Colour(1,1,1);
si.tcolour=Colour(1,1,1);
T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,4.5, 0,TIME));
T->rotateY(new FN_constant(K_random()*2*PI,0,TIME));
T->rotateY(Create_FN_linear_through(0,2*PI,0,TIME));
T->rotateX(new FN_constant(K_random()*2*PI,0,TIME));
T->translate(Create_TVector(p.x,p.y,p.z,0,TIME));
K_add_object(Transform_Object(Create_Static_Sphere(Vector(0,0,0),1,0,TIME,si),T));

}
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

STRC.smart_time_divide=true;

cam.fname="test/output";
cam.width=200; cam.height=200;
cam.C=
  Create_TVector(30,20,10, 0,TIME);
  //Create_TVector_linear_through(Vector(40,0,-50),Vector(40,0,50),0,TIME)
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 1,0,TIME);
cam.xs=cam.ys=new FN_constant(0.5, 0,TIME);
cam.end_time=TIME; cam.framesec=4;
cam.backdrop=Colour(0.4,0.4,0.7);
cam.sub=3;
cam.motion_blur=true;
cam.anti_alias=true;
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.7;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=8;
//ki.bv_ify=true;
Surface_Info si;

int i;

// checker board
si.kdr=0.9; si.ksr=0.7; si.n=2;
si.dcolour=Colour(0.4,0.8,0.9);
si.rcolour=Colour(1,1,1);
int j;
#define C_W 10
for(i=0;i<C_W;i++)
	for(j=0;j<C_W;j++){
		if((j+i)&1)
			si.dcolour=Colour(0.6,0.6,0.6);
		else
			si.dcolour=Colour(0.9,0.9,0.9);
		add_rectZ(Vector(-10+i*20.0/C_W,-10+j*20.0/C_W,-1),20.0/C_W,20.0/C_W,si);
	}

add_atom(Vector(0,0,5));


si.kdr=0.4; si.ksr=0.9; si.n=2;
si.dcolour=Colour(0.2,0.8,0.7);
si.rcolour=Colour(1,1,1);
Vector V[4]={
Vector(1,1,0),Vector(1,-1,0),Vector(-1,-1,0),Vector(-1,1,0)};

K_add_light(new Light(
  TVector(
    new FN_constant(30,0,TIME),
    new FN_constant(10,0,TIME),
    new FN_constant(20,0,TIME)
  ),
  Colour(0.8,0.8,0.8) ) );

}


