#include "timer.h"
#include <sys/resource.h>
#include <time.h>

extern "C" int getrusage(int who, struct rusage *rusage);
void Timer::start()
{
	struct rusage ru;
	getrusage(RUSAGE_SELF,&ru);
	utime=Float(ru.ru_utime.tv_sec)+1e-6*ru.ru_utime.tv_usec;
	stime=Float(ru.ru_stime.tv_sec)+1e-6*ru.ru_stime.tv_usec;
	rtime=time(0);
}

void Timer::stop()
{
	struct rusage ru;
	getrusage(RUSAGE_SELF,&ru);
	rtime=time(0)-rtime;
	Float a,b;
	a=Float(ru.ru_utime.tv_sec)+1e-6*ru.ru_utime.tv_usec;
	b=Float(ru.ru_stime.tv_sec)+1e-6*ru.ru_stime.tv_usec;
	utime=a-utime;
	stime=b-stime;
}

ostream& operator<<(ostream& os,Timer& t)
{
	os<<t.utime<<"u "<<t.stime<<"s "<<t.rtime<<"r";
	return os;
}

