#ifndef __TTRANSFORM_H
#define __TTRANSFORM_H

#include "transform.h"
#include "function.h"

/* this is a temporal version of "transform.h" */


class TMatrix{
public:
	TMatrix(Float,Float);
	Matrix operator()(Float t);
	Function *r1,*r2,*r3,*r4,*r5,*r6,*r7,*r8,*r9,*tx,*ty,*tz;
	Float t0,t1;
};

// matrix multiply
TMatrix operator* (TMatrix& a, TMatrix& b);

class TTransformation{
public:
	TMatrix Ttrans,Tinverse;
	Float last_t; // last evaluation of t
	Float t0,t1;
	Matrix inverse;
	void rotateX(Function*);
	void rotateY(Function*);
	void rotateZ(Function*);
	void translate(TVector);
	void scale(TVector);
	void post_mult(TTransformation*);
	virtual void eval_inverse(Float t);
	TTransformation(Float,Float);
	TTransformation(Transformation*,Float T0, Float T1);

	virtual bool is_linear(){return false;}
};

// transform vectors ## make these inline??
Vector transform_point(const Matrix& a, const Vector& b);
Vector transform_normal(const Matrix& a, const Vector& b);
Vector transform_normalT(const Matrix& a, const Vector& b);//transpose

// actually create objects with a transformation
// NOTE: only a shallow copy of Transformation is made!
class TTransformed_Object: public Object{
public:
	Object* obj;
	TTransformation* T;
	TTransformed_Object(Object* o,TTransformation* t,Surface_Info &s);
	virtual bool intersect(Ray&,Float&);
	virtual void aux_info(Ray&,Intersect_Info&,Shade_Info&);
	virtual void compute_bounds(BV&);
	virtual bool inside(AA_Box&);
};

Object* Transform_Object(Object*,TTransformation*,Surface_Info&);
inline Object* Transform_Object(Object* o,TTransformation* t)
	{ return Transform_Object(o,t,o->surface);}


#endif

