#include "tvector.h"

TVector Create_TVector(Float x,Float y,Float z,Float t0, Float t1)
{
	return TVector(
		new FN_constant(x,t0,t1),
		new FN_constant(y,t0,t1),
		new FN_constant(z,t0,t1)
	);
}

TVector Create_TVector_linear_through(Vector& a,Vector& b,Float t0,Float t1)
{
	return TVector(
	  Create_FN_linear_through(a.x,b.x,t0,t1),
	  Create_FN_linear_through(a.y,b.y,t0,t1),
	  Create_FN_linear_through(a.z,b.z,t0,t1)
	);
}

TVector Create_TVector_ease_through(Vector& a,Vector& b,Float t0,Float t1)
{
	return TVector(
	  Create_FN_ease_through(a.x,b.x,t0,t1),
	  Create_FN_ease_through(a.y,b.y,t0,t1),
	  Create_FN_ease_through(a.z,b.z,t0,t1)
	);
}

TVector Create_TVector_composite(TVector* list,int n,Float t0, Float t1)
{
	Function** xlist=new Function* [n];
	Function** ylist=new Function* [n];
	Function** zlist=new Function* [n];
	for(int i=0;i<n;i++){
		xlist[i]=list[i].xfn;
		ylist[i]=list[i].yfn;
		zlist[i]=list[i].zfn;
	}
	return TVector(
		new FN_composite(n,xlist,t0,t1),
		new FN_composite(n,ylist,t0,t1),
		new FN_composite(n,zlist,t0,t1)
	);
}




