#ifndef __TVECTOR_H
#define __TVECTOR_H

// class for a vector that is a function of t

#include "function.h"
#include "vector.h"

class TVector{
public:
	TVector(Function* X=Function::zero,
	 Function* Y=Function::zero, Function* Z=Function::zero):
		xfn(X),yfn(Y),zfn(Z){}
	// evaluate components
	inline Float x(Float t) {return (*xfn)(t);}
	inline Float y(Float t) {return (*yfn)(t);}
	inline Float z(Float t) {return (*zfn)(t);}
	// evaluate vector
	inline Vector operator()(Float t){ return Vector(x(t),y(t),z(t));}

	Function *xfn,*yfn,*zfn;
};

TVector Create_TVector(Float,Float,Float,Float t0, Float t1);

TVector Create_TVector_linear_through(Vector&,Vector&,Float t0,Float t1);
TVector Create_TVector_ease_through(Vector&,Vector&,Float t0,Float t1);
TVector Create_TVector_composite(TVector*,int n,Float t0, Float t1);

#endif

